<script lang="ts">
import Vue from 'vue';
import error404 from '~/components/error/404-error.vue';

export default Vue.extend({
  name: 'Error',
  props: {
    error: {
      type: Object,
      default: () => {},
      required: false,
    },
  },
  head() {
    let path;
    if (this.$route.path === '/') {
      path = 'https://about.gitlab.com/';
    } else if (this.$route.path.endsWith('/')) {
      path = `https://about.gitlab.com${this.$route.path}`;
    } else {
      path = `https://about.gitlab.com${this.$route.path}/`;
    }
    const title = `${this.error.statusCode} | GitLab`;
    return {
      title,
      link: [
        {
          rel: 'canonical',
          href: path,
        },
      ],
      htmlAttrs: {
        lang: this.$i18n.locale,
      },
    };
  },
  computed: {
    errorPage() {
      return error404;
    },
  },
});
</script>

<template>
  <component
    :is="errorPage"
    :error="error"
    :status-code="error.statusCode"
    :message="error.message"
  />
</template>
